// chrome.browserAction.onClicked.addListener(function () {
//     chrome.tabs.executeScript(null,{file:"script.js"});
// });

var options={
    type:"basic",
    title:"Testing Whiz",
    message:"Your session is being recorded.",
    iconUrl:"icon.png"
};

function callback() {
    console.log("just Testing");
}
/*
*The following function injects scripts whenever user switches tab or reloads.
*/
chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
    chrome.windows.getCurrent(function (window) {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
            //Retrieves Flags from the FlagServer and inject's only when Flag value is 1
            //For details check FlagServer.java
            var root = 'https://localhost:8096/flag';
            $.ajax({
                url: root ,
                method: 'POST',
                data: JSON.stringify({"id":window.id,"force":0})
            }).then(function(data) {
                var json=jQuery.parseJSON(data);
                if(json.notify===1)
                    chrome.notifications.create(options,callback);
                if(json.flag===1 && tabs[0].title!=="TestingWhiz External Recording" && tab.title!=="localhost:8096/" && tabs[0].title!=="https://localhost:8096") {
                    chrome.tabs.executeScript(null, {allFrames: true, file: "engine.js"}, function () {
                        chrome.tabs.executeScript(null, {allFrames: true, file: "listener.js"}, function () {
                            chrome.tabs.executeScript(null, {
                                allFrames: true,
                                file: "handlerFunctions.js"
                            }, function () {
                                chrome.tabs.executeScript(null, {allFrames: true, file: "shortEvent2.js"}, function () { 

                                });
                            });
                        });
                    });
                }
            });
        });
    });
});


/*
* Check for move to window
 */
function moveToWindow(tabs,tab) {
    listener.getWindowName(function (name) {
        console.log("Murtuza move old::"+name);
        console.log("Murtuza new values title::"+tabs[0].title+"--"+tab.title);
        console.log("Murtuza new values title::"+tabs[0].url+"--"+tab.url);
        if ((tabs[0].title !== name && tab.title !== name) || (tabs[0].url !== name && tab.url !== name)) {
            if (!tabs[0].title)
                listener.setWindowName(tabs[0].title);
            else if (!tab.title)
                listener.setWindowName(tab.title);
            else if (!tabs[0].url)
                listener.setWindowName(tabs[0].url);
            else
                listener.setWindowName(tab.url);
        }
    })
}