// Provide a default path to dwr.engine
if (typeof this['dwr'] == 'undefined') this.dwr = {};
if (typeof dwr['engine'] == 'undefined') dwr.engine = {};

if (typeof this['listener'] == 'undefined') this.listener = {};

//Listener.js needs to be in sync with RecordFunction class
//For details go to https://localhost:8096/whizdwr after starting recording
//Also check RecordFunction

listener._path = 'https://localhost:8096/whizdwr';

listener.setFrameIndex = function(p0, callback) {
    dwr.engine._execute(listener._path, 'listener', 'setFrameIndex', p0, callback);
};

listener.getFrameIndex = function(callback) {
    dwr.engine._execute(listener._path, 'listener', 'getFrameIndex', callback);
};

listener.getFrameStack = function(callback) {
    dwr.engine._execute(listener._path, 'listener', 'getFrameStack', callback);
};

listener.setFrameStack = function(p0, callback) {
    dwr.engine._execute(listener._path, 'listener', 'setFrameStack', p0, callback);
};

listener.registerClick = function(p0, p1, p2, p3, p4, callback) {
    dwr.engine._execute(listener._path, 'listener', 'registerClick', p0, p1, p2, p3, p4, callback);
};

listener.windowClosed = function(p0, p1, callback) {
    dwr.engine._execute(listener._path, 'listener', 'windowClosed', p0, p1, callback);
};

listener.setFrameName = function(p0, callback) {
    dwr.engine._execute(listener._path, 'listener', 'setFrameName', p0, callback);
};

listener.registerChange = function(p0, p1, p2, p3, callback) {
    dwr.engine._execute(listener._path, 'listener', 'registerChange', p0, p1, p2, p3, callback);
};

listener.getFrameName = function(callback) {
    dwr.engine._execute(listener._path, 'listener', 'getFrameName', callback);
};

listener.playSound = function(p0, callback) {
    dwr.engine._execute(listener._path, 'listener', 'playSound', p0, callback);
};

listener.registerType = function(p0, p1, p2, p3, p4, callback) {
    dwr.engine._execute(listener._path, 'listener', 'registerType', p0, p1, p2, p3, p4, callback);
};

listener.printLog = function(p0, callback) {
    dwr.engine._execute(listener._path, 'listener', 'printLog', p0, callback);
};

listener.windowOpen = function(p0, callback) {
    dwr.engine._execute(listener._path, 'listener', 'windowOpen', p0, callback);
};

listener.setWindowName = function(p0, callback) {
    dwr.engine._execute(listener._path, 'listener', 'setWindowName', p0, callback);
};

listener.getWindowName = function(callback) {
    dwr.engine._execute(listener._path, 'listener', 'getWindowName', callback);
};

listener.moveOutOfFrame = function(callback) {
    dwr.engine._execute(listener._path, 'listener', 'moveOutOfFrame', callback);
};
