	var oldTargBg; 
	var oldTargClr; 
	var oldTarg; 	
	
	var inputTarg = null;
	var inputXP = '';

	var selectTagsChanged = false;
	
	function getXPathForElement(el, xml) 
	{		  
		var absolute = true;
        var xpath = "";  
        var pos, tempitem2;

        while(el !== xml.documentElement) 
        {       
            pos = 0;  
            tempitem2 = el;  
            
            while(tempitem2) 
            {  
                if (tempitem2.nodeType === 1 && tempitem2.nodeName === el.nodeName) 
                {   
                    pos += 1;  
                }  
                
                tempitem2 = tempitem2.previousSibling;  
            }  
              
            if(el.id == undefined || el.id == "")
            	xpath = el.nodeName + (pos == 1? "" :"[" + pos + "]") + "/" + xpath;
            else
            {
            	try
            	{
	            	xpath = "//" + el.nodeName + "[@id='" + el.id + "']" + (xpath == "" ? "" : "/" + xpath);
	            	absolute = false
	            	break;
            	}
            	catch(e)
            	{
            		alert(e);
            	}
            }
            
            el = el.parentNode;  
        }
        
        if(absolute)
        	xpath = xml.documentElement.nodeName + '/' + xpath;
        
        xpath = xpath.replace(/\/$/, '');
		
        return xpath;    
	}
	
	function getAbsoluteXPathForElement(el, xml)
	{
		var xpath = '';
		var pos, tempitem2;
		
		while(el !== xml.documentElement)
		{
			pos = 0;
			tempitem2 = el;
			
			while(tempitem2) 
			{
				if (tempitem2.nodeType === 1 && tempitem2.nodeName === el.nodeName)
				{
					pos += 1; 
				}
				tempitem2 = tempitem2.previousSibling;  
			}
			
			xpath = el.nodeName+(pos == 1? '' :'[' + pos + ']') + '/' + xpath;''
			el = el.parentNode; 
		}
			
		xpath = xml.documentElement.nodeName + '/' + xpath;
		xpath = xpath.replace(/\/$/,'');
		return xpath;
	}
	
	
	document.onmousedown = function(e)
	{		
		selectTagsChanged = false;
		modifySelectTags();
		var clicked = false;
		var targ;
		
		if (!e) 
			var e = window.event;
		
		if (e.target) 
			targ = e.target; 
		else if (e.srcElement) 
			targ = e.srcElement; 
		if (targ.nodeType == 3) 
			targ = targ.parentNode;		
		
		//Cover Formatted Links upto 2 levels within Anchor tag - Fix for http://192.192.7.3:100/mantis/view.php?id=8878
		if( targ.parentNode != null && (targ.parentNode.tagName == 'A' && targ.tagName != 'IMG') )
		{
			targ = targ.parentNode;
			
			if( targ.parentNode.parentNode != null && targ.parentNode.parentNode.tagName == 'A' )
				targ = targ.parentNode.parentNode;
		}
		
//		var clickCondition = targ.onclick || ( targ.type == 'radio' || targ.type == 'checkbox' ) || ( e.button != 0 && e.button != 1 );
//		var pointerCursor = targ.style.cursor = 'pointer';
//		
//		if( clickCondition || targ.tagName == 'A' || targ.tagName == 'IMG' || targ.tagName == 'AREA' || targ.tagName == 'BUTTON' || targ.type == 'submit' || targ.type == 'image' || targ.type == 'button' || targ.type == 'submit' || targ.type == 'file')
//		{
			var xp;
			
			if(targ.tagName == 'A' && targ.href.indexOf('javascript' != -1))
				xp = getAbsoluteXPathForElement(targ, document);
			else
				xp = getXPathForElement( targ, document );
			
			var href = null;
			
			try
			{
				//if( targ.tagName == 'A' )
					//registerClick( get(targ.id), get(targ.name), targ.tagName, get(targ.type), xp, targ.href, targ.innerHTML, e.button, getCumulativeOffset(targ) );
				if(targ.tagName != 'SELECT')
					registerClick( getTarget(targ), getCumulativeOffset(targ), e.button );
				//else
					//registerClick( get(targ.id), get(targ.name), targ.tagName, get(targ.type), xp, get(targ.innerHTML), e.button, getCumulativeOffset(targ) );
			}
			catch(err)
			{
				scriptError( "Register Click error", err.message );
			}
			
			clicked = true;
//		}		
		
		//Handle Autocomplete - Start
		if( inputTarg != null )
		{
			if( !clicked )
			{
				setTimeout(delayedType, 100);								
			}
			
		}
		//Handle Autocomplete - End
	};
	
	function delayedType()
	{
		//registerType( get(inputTarg.id), get(inputTarg.name), inputTarg.tagName, inputTarg.type, inputXP, get(inputTarg.value), 65, null, getCumulativeOffset(targ) );
		
		registerType( getTarget(inputTarg), getCumulativeOffset(inputTarg), 65 );
		inputTarg = null;
		inputXP = '';
	}
	
	document.onkeyup = function(e)
	{
		selectTagsChanged = false;
		modifySelectTags();
		var targ; 
		
		if (!e) 
			var e = window.event;
		
		if( !( e.keyCode == 115 || e.keyCode == 119 || e.keyCode == 120 ) )//Special Keys
		{
			if (e.target) 
				targ = e.target; 
			else if (e.srcElement) 
				targ = e.srcElement; 
			
			if( targ )
			{
				if (targ.nodeType == 3) 
					targ = targ.parentNode;
				
				var xp = getXPathForElement( targ, document );
				
				try
				{
					if( targ.tagName == 'INPUT' || targ.tagName == 'TEXTAREA' )
					{
						inputXP = xp;
						inputTarg = targ;
						//registerType( get(targ.id), get(targ.name), targ.tagName, targ.type, xp, get(targ.value), e.keyCode, null, getCumulativeOffset(targ) );
						
						registerType( getTarget(inputTarg), getCumulativeOffset(inputTarg), e.keyCode );
					}
				}
				catch(err)
				{
					scriptError( "Register Type error", err.message );
				}	
			}
		}
	
	};	
	
	document.onkeydown = function(e)
	{
		var targ; 
		
		if (!e) 
			var e = window.event;
		
		if( !( e.keyCode == 115 || e.keyCode == 119 || e.keyCode == 120 ) )//Special Keys
		{
			if (e.target) 
				targ = e.target; 
			else if (e.srcElement) 
				targ = e.srcElement; 
			
			if( targ )
			{
				if (targ.nodeType == 3) 
					targ = targ.parentNode;
				
				var xp = getXPathForElement( targ, document );
				
				try
				{
					if( targ.tagName == 'INPUT' || targ.tagName == 'TEXTAREA' )
					{
						playSound("keydown");
					}
				}
				catch(err)
				{
					scriptError( "Keydown error", err.message );
				}
			}
		}
	};
	
	document.onmouseover = function(e) 
	{
		var targ;
		var targType = "";
		
		if (!e)
			var e = window.event;
		if (e.target)
			targ = e.target;
		else if (e.srcElement)
			targ = e.srcElement;
		if (targ.nodeType == 3) // defeat Safari bug
			targ = targ.parentNode;
		//console.log(targ.id);
		
		if( oldTarg )
		{
			oldTarg.style.backgroundColor = oldTargBg;
			oldTarg.style.color = oldTargClr;
		}
		
		oldTargBg = targ.style.backgroundColor;
		oldTargClr = targ.style.color;
		
		oldTarg = targ;
		targ.style.backgroundColor = "#FDFFCC";
		targ.style.color = "#000000";
		
		var xpath = getXPathForElement(targ, document);
		
		if( targ.tagName == 'INPUT' )
			targType = targ.type;
		
		try
		{
			objectSpy( get(targ.id), get(targ.name), targ.tagName, get(targType), xpath, get(targ.innerHTML), get(targ.className), get(getCSSPath(targ)), get(targ.value));
			//objectSpy( getTarget(targ), getCumulativeOffset(targ) );
		}
		catch(err)
		{
		 	scriptError( "Object Spy error", err.message );
		}	
	};
	
	 //Select Tags
	 if(window.attachEvent) 
	 {
		window.attachEvent('onload', modifySelectTags);
		scriptLog( "Attached modifySelectTags to onload" );
	 }
	 else 
	 {
		if(window.onload) 
		{
			var curronload = window.onload;
			var newonload = function() 
			{
				curronload();
				modifySelectTags();
			};
			window.onload = newonload;
			
			scriptLog( "Added modifySelectTags to defined onload" );
		}
		else 
		{
			window.onload = modifySelectTags;
			
			scriptLog( "Defined modifySelectTags as onload" );
		}
	}
	
	function modifySelectTags()
	{
		if( ! selectTagsChanged )
		{
			selectTagsChanged = true;
			scriptLog( "Checking select tags" );
			
			var x = document.getElementsByTagName( 'SELECT' );
			
			scriptLog( "Select tags found: " + x.length );
			
			if( x.length > 0 )
				addPostToOnChange( x );
		}
	}
	
	function addPostToOnChange( arr )
	{
		var obj;
		var onChangeFunction = "";
		var changeFunction = true;
		var postChangeFunc = "postOnChangeToCAT();";
		
		try
		{
			for( var i = 0; i < arr.length; i ++ )
			{
				obj = arr[i];
				
				onChangeFunction = "";
				postChangeFunc = "postOnChangeToCAT();";
				changeFunction = true;
				
				
				if (obj.onchange != null) 
				{
					if( obj.onchange.toString().indexOf( "eval(postChangeFunc)" ) == -1 )//Make sure only added once
					{
						onChangeFunction = obj.onchange.toString()
							.replace("function anonymous()", "")
							.replace("function anonymous(event)", "") // Solved Mantis issue : 0009013: Unable to record dropdown value. 
							.replace("function onchange()", "")
							.replace("function onchange(event)", "")
							.replace("{\n", "")
							.replace("\n}", "")
							.replace("\n", "");
					
						//scriptLog( "postOnChangeToCAT not present in " + obj.onchange.toString() );
						
						postChangeFunc = postChangeFunc + onChangeFunction + ";scriptLog('onchange Called for ' + window.event.type);";						
					}
					else
					{
						changeFunction = false;
					}
				}
				
				if( changeFunction )
				{
					futureFunction(obj,postChangeFunc);
				}
			}
		}
		catch(err)
		{
			scriptError( "Select Tag Modify error", err.message );
		}
	}
	function futureFunction(obj,postChangeFunc)
	{
		scriptLog( "Adding on change function to [name=" + obj.name + ";id="+ obj.id + "] :: " + postChangeFunc );
		
		obj.onchange = function(e) {
			eval(postChangeFunc);
		};		
	}
	function postOnChangeToCAT()
	{
		try
		{
			var targ;
			var selectVal;
			
			if (!e) 
				var e = window.event;
			
			if (e.target) 
				targ = e.target; 
			else if (e.srcElement) 
				targ = e.srcElement; 
			if (targ.nodeType == 3) 
				targ = targ.parentNode;
			
			var xp = getXPathForElement( targ, document );
			
			try
			{
				registerChange( getTarget(targ), getCumulativeOffset(targ) );
				//registerChange( get(targ.id), get(targ.name), targ.tagName, xp, get(selectVal), getCumulativeOffset(targ) );
			}
			catch(err)
			{
				scriptError( "Register change error", err.message );
			}
		}
		catch(err)
		{
			scriptError( "Register change error", err.message );
		}
	}
	
	function getLeftClickCode()
	{
		if( navigator.appName.indexOf( "Microsoft Internet Explorer" ) != -1 )
		{
			if ( navigator.appVersion.indexOf("MSIE 6.") != -1
				|| navigator.appVersion.indexOf("MSIE 7.") != -1
				|| navigator.appVersion.indexOf("MSIE 8.") != -1 
				|| document.URL == "about:blank")//A rare MS IE 9 gem - about:blank follows old codes of 1, 2, 4 for mouse clicks!
			{
				return 1;//For IE<9
			}	
		}
		
		return 0;//For all others
	}
	
	function lastCheckSelectTags()//For LAN sites that load fast and before this script is run
	{
		if( ! selectTagsChanged )
			modifySelectTags();
	}
	
	function get(obj)//Returns non-null object - IE9 change
	{
		if( obj != null && obj != "" )		
			return obj;
		else
			return "";
	}
	
	function getTarget(targ)//Get all target properties in a map 
	{
		var map = null;
		
		if( targ.tagName == "SELECT" )
		{
			var selectVal = targ.options[ targ.selectedIndex ].text;
			
			map =
		    [
		        "name::" + get(targ.name),
		        "id::" + get(targ.id),
		        "tagName::" + targ.tagName,
		        "xpath::" + getXPathForElement( targ, document ),
		        "value::" + get(selectVal),
		        "innerHTML::" + get(targ.innerHTML),
		        "className::" + get(targ.className),
		        "cssPath::" + get(getCSSPath(targ))
		    ];
		}
		else if( targ.tagName == "A" )
		{
			var xp;
			
			if(targ.href.indexOf('javascript' != -1) || (targ.href.indexOf('(' != -1) && targ.href.indexOf(')' != -1)))
				xp = getAbsoluteXPathForElement(targ, document);
			else
				xp = getXPathForElement( targ, document );
		
			map =
		    [
				"name::" + get(targ.name),
		        "id::" + get(targ.id),
		        "tagName::" + targ.tagName,
		        "xpath::" + xp,
		        "value::" + get(targ.href),
		        "innerHTML::" + get(targ.innerHTML),
		        "className::" + get(targ.className),
		        "cssPath::" + get(getCSSPath(targ))
		    ];
		}
		else if( targ.tagName == "IMG" ||  targ.tagName == "AREA" )
		{
			map =
		    [
				"name::" + get(targ.alt),
		        "id::" + get(targ.id),
		        "tagName::" + targ.tagName,
		        "type::" + get(targ.type),
		        "xpath::" + getXPathForElement( targ, document ),
		        "value::" + get(targ.value),
		        "innerHTML::" + get(targ.innerHTML),
		        "className::" + get(targ.className),
		        "cssPath::" + get(getCSSPath(targ))
		    ];
		}
		else
		{
			map =
		    [
				"name::" + get(targ.name),
		        "id::" + get(targ.id),
		        "tagName::" + targ.tagName,
		        "type::" + get(targ.type),
		        "xpath::" + getXPathForElement( targ, document ),
		        "value::" + get(targ.value),
		        "innerHTML::" + get(targ.innerHTML),
		        "className::" + get(targ.className),
		        "cssPath::" + get(getCSSPath(targ))
		    ];
		}
		
		return map;
	};
	
	function previousElementSibling (element) 
	{
	  if (element.previousElementSibling !== 'undefined') 
	  {
	    return element.previousElementSibling;
	  }
	  else 
	  {
	    // Loop through ignoring anything not an element
	    while (element = element.previousSibling) 
	    {
	      if (element.nodeType === 1) 
	      {
	        return element;
	      }
	    }
	  }
	}
	
	function getCSSPath (element) 
	{
	  try
	  {
		  // False on non-elements
		  if (!(element instanceof HTMLElement)) 
		  {
		  	return false; 
		  }
	  }
	  catch(e)
	  {
	  	return false;
	  }
	  	  
	  var path = [];
	  
	  while (element.nodeType === Node.ELEMENT_NODE) 
	  {
	    var selector = element.nodeName;
	    
	    if (element.id) 
	    {
	    	selector += ('#' + element.id); 
	    }
	    else 
	    {
	      // Walk backwards until there is no previous sibling
	      var sibling = element;
	      // Will hold nodeName to join for adjacent selection
	      var siblingSelectors = [];
	      while (sibling !== null && sibling.nodeType === Node.ELEMENT_NODE) {
	        siblingSelectors.unshift(sibling.nodeName);
	        sibling = previousElementSibling(sibling);
	     }
	     // :first-child does not apply to HTML
	     if (siblingSelectors[0] !== 'HTML') 
	     {
	        siblingSelectors[0] = siblingSelectors[0] + ':first-child';
	     }
	     
	     selector = siblingSelectors.join(' + ');
	    }
	    path.unshift(selector);
	    element = element.parentNode;
	  }
	  
	  return path.join(' > ');
	}
	
	function getCumulativeOffset(obj)//Get cumulative x and y co-ordinates of an object 
	{

		var left, top;
		var clientWidth = obj.clientWidth;
		var clientHeight = obj.clientHeight;
		
	    left = top = 0;
	    if (obj.offsetParent) 
	    {
	        do 
	        {
	            left += obj.offsetLeft;
	            top  += obj.offsetTop;
	        } 
	        while (obj = obj.offsetParent);
	    }
	    
	    var map =
	    [
	        "x::" + left,
	        "y::" + top,
	        "w::" + clientWidth,
	        "h::" + clientHeight
	    ];
        // console.log("My Onject:"+map.toString());
	    return map;
	};
	
	function checkBrowserVersions()
	{
		if (navigator.userAgent.indexOf('MSIE') !== -1 || navigator.appVersion.indexOf('Trident/') > 0)
		{
			return "";//Added for IE9 - which expects the script to return something
		}
	}
	
	lastCheckSelectTags();
	
	scriptLog( "End of recorder script reached" );
	
	checkBrowserVersions();
	
	window.onunload = function()
	{
		scriptLog("Closing...");
  		closeRecorder();
	}