var inFrame = false;
var inWindow = false;
var current =null;
 
if (top === self) 
{
	//Do nothing
}
else
{
	inFrame = true;
}

if (window.opener !== null && !window.opener.closed)
{
	if(window.opener.location.href !== window.location.href)
	{
		scriptLog("Popup window open...");
		inWindow = true;
	}
	
}	
else
{
	scriptLog("Parent does not exist...");
}

function scriptLog(msg)
{
	console.log(msg);
	listener.printLog(msg);
}

function scriptError(prefix, errMsg)
{
	console.error(prefix + ": " + errMsg);
}

function objectSpy(id, name, tagName, targType, xpath, innerHTML)
{
    //TODO: Find a way to display xpath
}

function registerClick(target, offset, button)
{
	console.log("Recording Click");
	console.log("Offset:"+offset.toString());
	scriptLog("Checking for Window title -> "+document.getElementsByTagName('title')[0]);
	
	checkFrameAndWindow();
	//100ms is the response time of Listener server
    //Delay is added to sync with Callback function
	setTimeout(function () {
        if(document.getElementsByTagName('title')[0] !== undefined)
        {
            listener.registerClick(document.location.href,
                document.getElementsByTagName('title')[0].innerHTML, target, offset, button);
        }
        else
        {
            listener.registerClick(document.location.href,
                "", target, offset, button);
        }
    },100);
}

function registerType(target, offset, code)
{
	console.log("Recording Type with keycode : " + code);
	scriptLog("Checking for Window title -> "+document.getElementsByTagName('title')[0]);

	if(code === 9)//keypress.TAB
	{	
		checkFrameAndWindow();//Record frame only when TAB key is pressed.
	}
	if(document.getElementsByTagName('title')[0] !== undefined)
	{
		listener.registerType(document.location.href, 
			document.getElementsByTagName('title')[0].innerHTML, target, offset, code);
	}
	else
	{
		listener.registerType(document.location.href, 
				"", target, offset, code);
	}
}

function playSound(sound)
{
	listener.playSound(sound);
}

function registerChange(target, offset)
{
	console.log("Recording Select change");
	scriptLog("Checking for Window title -> "+document.getElementsByTagName('title')[0]);
	
		console.log("TagName::::"+target[2]);
		var tag = target[2];
		
		if(tag.match(/tagName:::/gi))//record frame only when select tag is changed
		{
			console.log("tagname:: found");
			var targPair = tag.split(':::');
			if(targPair[1].match(/select/gi))
			{
				console.log("select tag:: found");
				checkFrameAndWindow();
			}
		}

//	checkFrameAndWindow();
	
	if(document.getElementsByTagName('title')[0] !== undefined)
	{
		listener.registerChange(document.location.href, 
			document.getElementsByTagName('title')[0].innerHTML, target, offset);
	}
	else
	{
		listener.registerChange(document.location.href, 
				"", target, offset);
	}
}

function checkFrameAndWindow() {
    console.log("Checking frame & window");
    if(inWindow){
        var winName = document.title;
        //Effort to make it Synchronous
        var oldWin=null;

        //Handle Move to window
        //Move only when current window name or url doesn't match the previous one
        //Listener server keeps track all the stacks
        //For Details check RecordFunction.java
        listener.getWindowName(function (val) {
            oldWin=val;
            console.log("window name ->"+val);
        });
        setTimeout(function () {
            if(oldWin===null){
                if(winName===null) {
                    winName = window.location.href;
                    listener.setWindowName(winName);
                    console.log("window url ->" + winName);
                }else {
                    listener.setWindowName(winName);
                    console.log("window name ->"+winName);
                }
            }
            else  if(winName !== oldWin && window.location.href!==oldWin)
            {
                listener.setWindowName(winName);
                console.log("window name ->"+winName);
            }
        },100);
    }
    //Handle Move to frame
    //Move only if frame stack doesn't match previous one
    //Frame index stack is maintained . To Handle move to nested frame too.
    if(inFrame) {
        var stack = null;
        listener.getFrameStack(function (val) {
            stack = val;
        });
        console.log("Server stack::"+stack);
        setTimeout(function () {
            try {
                var indexStack = getFrameIndex();
                console.log("Stack::"+indexStack);
                if(indexStack.length===0){
                    indexStack = getIframeIndex();
                }
                var currentStack=getStack(indexStack);
                if(stack===null){
                    listener.setFrameStack(currentStack);
                    for (var i=indexStack.length-1;i>=0;i--){
                        listener.setFrameIndex(indexStack[i].index);
                        listener.setFrameName(indexStack[i].name);
                    }
                }
                else if(stack!==currentStack){
                    listener.setFrameStack(currentStack);
                    listener.moveOutOfFrame();
                    for (var i=indexStack.length-1;i>=0;i--){
                        listener.setFrameIndex(indexStack[i].index);
                        listener.setFrameName(indexStack[i].name);
                    }
                }
            }catch (e){
                //It is forbidden to enter Frame with other origin
                //This piece of code handles it
                console.log("Error: " + e);
                var re=new RegExp(".*\"(.+)\".*");
                if(re.exec(e)!==null) {
                    var src = re.exec(e)[1];
                    var frame;
                    if (src.endsWith("/")) {
                        console.log("yes");
                        frame=".//iframe[@src='"+src+"']";
                    }
                    else {
                        console.log(src + "/");
                        frame=".//iframe[@src='"+src+"/"+"']";
                    }

                    listener.getFrameName(function (val) {
                        console.log("got Frame fRom:::::::::::::"+val);
                    });

                    setTimeout(function () {
                        if(current===null){
                            listener.setFrameName(frame);
                            current=frame;
                        }
                    },100);
                }
            }
        }, 100);
    }
    else {
        listener.getFrameStack(function (val) {
            if(val!==null){
                listener.moveOutOfFrame();
                listener.setFrameStack(null);
            }
        });
    }

}

function getStack(stack) {
    var array=null;
    for (var i=0;i<stack.length;i++){
        array+=stack[i].index;
    }
    return array;
}


//TODO: Combine both frame and iframe get index functions

function getFrameIndex( )
{
    var currentParent=self;
    var indexArray = new Array();
    while(currentParent!==top){
        var currentSelf=currentParent;
        currentParent=currentParent.parent;
        var pf = currentParent.document.getElementsByTagName( 'frame' );
        scriptLog("Total no of Frames..."+pf.length);
        for( var i = 0, found = -1; pf[ i ] && found === -1; i++ )
            try
            {
                if( pf[ i ].contentWindow === currentSelf ){
                    var indexObject=new Object();
                    indexObject["index"]=""+i;
                    if(currentSelf.name.substring(0,3) === "DWR")
                        indexObject["name"]="";
                    else
                        indexObject["name"]=currentSelf.name;
                    indexArray.push(indexObject);
                }
            }
            catch( e ){
                console.log("Error in Frame: " + e);
            }
    }
    console.log(indexArray);
    console.log("--------------done---------------");
  return indexArray;
}

function getIframeIndex()
{
    var currentParent=self;
    var indexArray = new Array();
    while(currentParent!==top){
        var currentSelf=currentParent;
        currentParent=currentParent.parent;
        var pf = currentParent.document.getElementsByTagName( 'iframe' );
        scriptLog("Total no of iFrames..."+pf.length);
        for( var i = 0, found = -1; pf[ i ] && found == -1; i++ )
            try
            {
                if( pf[ i ].contentWindow === currentSelf ){
                    var indexObject=new Object();
                    indexObject["index"]=""+i;
                    if(currentSelf.name.substring(0,3) == "DWR")
                        indexObject["name"]="";
                    else
                        indexObject["name"]=currentSelf.name;
                    indexArray.push(indexObject);
                }
            }
            catch( e ){
                console.log("Error in iFrame: " + e);
            }
    }
    console.log(indexArray);
    console.log("--------------done---------------");
    return indexArray;
}

//window.onclose = function()
//{
//	scriptLog("Closing window!");
//	
//	listener.windowClosed(document.location.href, 
//			document.getElementsByTagName('title')[0].innerHTML);
//}